package body{
  import figure.Point3D;

//--------------------------------------------------------------------//
// 󋅃NX
  public class Sphere extends Body{

// \ܓx
    public static const NPHY:int=4;

// \ox
    public static const NTH:int=8;

// Oa
    public var ro:Number;

// a
    public var ri:Number;

// x
    public var density:Number;

//--------------------------------------------------------------------//
// ̂\z
// label f[^x
// ro - Oa
// ri - a
// density - x
    public function Sphere(label:int,ro:Number,ri:Number,
      	      	      	   density:Number){
      super(label);
      this.ro=ro;
      this.ri=ri;
      this.density=density;
      var ro3:Number=ro*ro*ro;
      var ri3:Number=ri*ri*ri;
      var mc:Number=4.0*Math.PI*density/3.0;
      mass=mc*(ro3-ri3);
      inertia[0][0]=0.4*mc*(ro3*ro*ro-ri3*ri*ri);
      inertia[1][1]=inertia[0][0];
      inertia[2][2]=inertia[0][0];
      pt=new Array(NPHY);
      for(var i:int=0;i<NPHY;i++){
      	pt[i]=new Vector.<Point3D>(NTH,true);
      	for(var j:int=0;j<NTH;j++){
      	  pt[i][j]=new Point3D();
      	}
      }
    }

//--------------------------------------------------------------------//
// ̌`\_̃XgԂ
    public override function vertices():Array{
      var dphy:Number=Math.PI/Number(NPHY);
      var dth:Number=2.0*Math.PI/Number(NTH);
      for(var i:int=0;i<NPHY;i++){
      	var phy:Number=dphy*(Number(i)+0.5)-0.5*Math.PI;
      	var cp:Number=ro*Math.cos(phy);
      	var sp:Number=ro*Math.sin(phy);
      	for(var j:int=0;j<NTH;j++){
      	  var th:Number=dth*Number(j);
      	  var x:Number=cp*Math.cos(th);
      	  var y:Number=cp*Math.sin(th);
      	  pt[i][j].set(x,y,sp);
      	}
      }
      p.trans(pt);
      return pt;
    }

//--------------------------------------------------------------------//
// f[^Ԃ
    public function toString():String{
      return "Sphere\t"+label+"\t"+ro+"\t"+ri+"\t"+density;
    }
  }
}
