package constraint{
  import flash.geom.Vector3D;
  import figure.DefaultMatrix;
  import figure.Point3D;

//--------------------------------------------------------------------//
// ]~WCg
  public class CylinderJoint extends AbstractRigidConstraint{

// S鎩Rx
    public static const DOF:int=4;

// SΏە̂P̈ړ
    protected var s1:Vector3D;

// SΏە̂Q̈ړ
    protected var s2:Vector3D;

// ʒu
    protected var z0:Number;

//--------------------------------------------------------------------//
// ]~WCg\z
// p1 - SΏۈʒuP̃CfbNX
// p2 - SΏۈʒuQ̃CfbNX
// r1 - SΏە̂P̍Sʒu
// r2 - SΏە̂Q̍Sʒu
// z0 - ʒu
    public function CylinderJoint(p1:int,p2:int,r1:Point3D,r2:Point3D,
      	      	      	      	  z0:Number){
      super(p1,p2,r1,r2);
      this.z0=z0;
      vector=new Vector.<Number>(DOF,true);
      s1=new Vector3D(0.0,0.0,1.0,1.0);
      s2=new Vector3D(0.0,0.0,1.0,1.0);
      matrix[0]=new DefaultMatrix(DOF,6);
      matrix[1]=new DefaultMatrix(DOF,6);
    }

//--------------------------------------------------------------------//
// S鎩RxԂ
    public override function dof():int{
      return DOF;
    }

//--------------------------------------------------------------------//
// SΏە̂̎ݒ肷
// s1 - SΏە̂P̈ړ
// s2 - SΏە̂Q̈ړ
    public function setAxis(s1:Vector3D,s2:Vector3D):void{
      this.s1=s1;
      this.s2=s2;
    }

//--------------------------------------------------------------------//
// dSʒuExݒ肷
// p1 - SΏۈʒuP
// p2 - SΏۈʒuQ
    public override function setGcPosition(p1:Position,
      	      	      	      	      	   p2:Position):void{
      var ri:Point3D=new Point3D(r1.x+z0*s1.x,r1.y+z0*s1.y,
      	      	      	      	 r1.z+z0*s1.z);
      var x:Vector.<Number>=p1.vector(ri);
      var v:Vector.<Number>=p1.velVector(ri);
      p2.setGcPosition(r2,new Point3D(x[0],x[1],x[2]),
      	      	       new Vector3D(v[0],v[1],v[2],1.0));
    }

//--------------------------------------------------------------------//
// S}gbNXES׏dxNg쐬
// p1 - SΏۈʒuP
// p2 - SΏۈʒuQ
    public override function create(p1:Position,p2:Position):void{
      axis(p1,p2,s1,s2,0);
      direction(p1,p2,s1,2);
    }

//--------------------------------------------------------------------//
// f[^Ԃ
    public function toString():String{
      return "CylinderJoint\t"+pp1+"\t"+pp2+"\t"+r1.x+"\t"+r1.y
      	    +"\t"+r1.z+"\t"+r2.x+"\t"+r2.y+"\t"+r2.z+"\t"+z0;
    }
  }
}
