package constraint{
  import figure.Point3D;

//--------------------------------------------------------------------//
// ΂˗vf
  public class Spring extends AbstractConstraint{

// ΂˒萔
    protected var k:Number;

// R
    protected var l0:Number;

//--------------------------------------------------------------------//
// WCg\z
// p1 - SΏۈʒuP̃CfbNX
// p2 - SΏۈʒuQ̃CfbNX
// r1 - SΏە̂P̍Sʒu
// r2 - SΏە̂Q̍Sʒu
// k - ΂˒萔
// l0 - R
    public function Spring(p1:int,p2:int,r1:Point3D,r2:Point3D,
      	      	      	   k:Number,l0:Number){
      super(p1,p2,r1,r2);
      this.k=k;
      this.l0=l0;
    }

//--------------------------------------------------------------------//
// S鎩RxԂ
    public override function dof():int{
      return 3;
    }

//--------------------------------------------------------------------//
// S}gbNXES׏dxNg쐬
// p1 - SΏۈʒuP
// p2 - SΏۈʒuQ
    public override function create(p1:Position,p2:Position):void{
      var f:Vector.<Number>=new Vector.<Number>(3,true);
      if(p2!=null){
      	f=p2.vector(r2);
      }
      else{
      	f[0]=r2.x;
      	f[1]=r2.y;
      	f[2]=r2.z;
      }
      if(p1!=null){
      	var f2:Vector.<Number>=p1.vector(r1);
      	for(var i:int=0;i<3;i++) f[i]-=f2[i];
      }
      else{
      	f[0]-=r1.x;
      	f[1]-=r1.y;
      	f[2]-=r1.z;
      }
      var l:Number=Math.sqrt(f[0]*f[0]+f[1]*f[1]+f[2]*f[2]);
      var c:Number=k*(l-l0)/l;
      vector=Vector.<Number>([c*f[0],c*f[1],c*f[2],
      	      	      	      -c*f[0],-c*f[1],-c*f[2]]);
    }

//--------------------------------------------------------------------//
// f[^Ԃ
    public function toString():String{
      return "Spring\t"+pp1+"\t"+pp2+"\t"+r1.x+"\t"+r1.y+"\t"+r1.z
      	    +"\t"+r2.x+"\t"+r2.y+"\t"+r2.z+"\t"+k+"\t"+l0;
    }
  }
}
