package{
  import flash.display.Graphics;
  import flash.display.GraphicsPathCommand;
  import flash.display.Sprite;
  import flash.geom.Matrix3D;
  import flash.geom.Vector3D;
  import flash.text.TextField;
  import flash.text.TextFormat;

//--------------------------------------------------------------------//
// W
  public class Coordinates extends Sprite{

// Wx
    internal var label:Vector.<TextField>;

// W[_
    internal var axis:Vector.<Vector3D>;

// Wϊ}gbNX
    public var trans:Matrix3D;

// `R}h
    internal var commands:Vector.<int>;

// `W
    internal var coords:Vector.<Number>;

//--------------------------------------------------------------------//
// W\z
// size - W̕`TCY
// textFormat - x
    public function Coordinates(size:Number,textFormat:TextFormat):void{
      label=new Vector.<TextField>(3,true);
      label[0]=createField("X",textFormat);
      label[1]=createField("Y",textFormat);
      label[2]=createField("Z",textFormat);
      axis=new Vector.<Vector3D>(4,true);
      trans=new Matrix3D();
      commands=new Vector.<int>(6,true);
      coords=new Vector.<Number>(12,true);
      for(var i:int=0;i<3;i++){
      	addChild(label[i]);
      	commands[2*i]=GraphicsPathCommand.MOVE_TO;
      	commands[2*i+1]=GraphicsPathCommand.LINE_TO;
      }
      for(i=0;i<4;i++) axis[i]=new Vector3D();
      axis[1].x=size;
      axis[2].y=size;
      axis[3].z=size;
    }

//--------------------------------------------------------------------//
// ֐̒lvZ
// i - _̃CfbNX
// x - _̍Wi[z
    internal function createField(text:String,
      	      	      	      	  textFormat:TextFormat):TextField{
      var field:TextField=new TextField();
      field.defaultTextFormat=textFormat;
      field.text=text;
      field.selectable=false;
      field.height=field.textHeight+5;
      return field;
    }

//--------------------------------------------------------------------//
// W`悷
// graphics - `OtBbNX
// x,y - _`ʒu
    public function draw(graphics:Graphics,x:Number,y:Number):void{
      var vp:Vector3D=trans.transformVector(axis[0]);
      var x0:Number=x+vp.x;
      var y0:Number=y-vp.y;
      for(var i:int=0;i<3;i++){
      	vp=trans.transformVector(axis[i+1]);
      	coords[4*i]=x0;
      	coords[4*i+1]=y0;
      	coords[4*i+2]=x+vp.x;
      	coords[4*i+3]=y-vp.y;
      	label[i].x=x+vp.x;
      	label[i].y=y-vp.y-label[i].height;
      }
      graphics.drawPath(commands,coords);
    }
  }
}
