package{
  import flash.display.Graphics;
  import flash.display.GraphicsPathCommand;
  import flash.geom.Matrix3D;
  import flash.geom.Point;
  import flash.geom.Vector3D;
  import figure.Point3D;

//--------------------------------------------------------------------//
// ̕`NX
  public class DrawBody{

// `_ԍW̃Xg
    internal var vp:Array;

// `_̉ʏW̃Xg
    internal var p:Array;

// `R}h
    internal var commands:Vector.<int>;

// `W
    internal var coords:Vector.<Number>;

// `悷镨
    internal var body:Body;

// f̕\{
    internal var vCoef:Number;

// `_
    internal var po:Point3D;

//--------------------------------------------------------------------//
// ̕`\z
// body - `悷镨
// vCoef - f̕\{
// po - `_
    public function DrawBody(body:Body,vCoef:Number,po:Point3D){
      this.body=body;
      this.vCoef=vCoef;
      this.po=po;
      var pt:Array=body.vertices();
      vp=new Array(pt.length);
      p=new Array(pt.length);
      for(var i:int=0;i<pt.length;i++){
      	vp[i]=new Vector.<Vector3D>(pt[i].length,true);
      	p[i]=new Vector.<Point>(pt[i].length,true);
      	for(var j:int=0;j<pt[i].length;j++){
      	  vp[i][j]=new Vector3D(0.0,0.0,0.0,1.0);
      	  p[i][j]=new Point();
      	}
      }
      commands=new Vector.<int>();
      for(i=0;i<p.length;i++){
      	commands.push(GraphicsPathCommand.MOVE_TO);
      	for(j=0;j<p[i].length;j++){
      	  commands.push(GraphicsPathCommand.LINE_TO);
      	}
      }
      for(i=0;i<p.length-1;i++){
      	for(j=0;j<p[i].length;j++){
      	  commands.push(GraphicsPathCommand.MOVE_TO);
      	  commands.push(GraphicsPathCommand.LINE_TO);
      	}
      }
      coords=new Vector.<Number>(2*commands.length,true);
    }

//--------------------------------------------------------------------//
// `悷
// graphics - `OtBbNX
// trans - Wϊ}gbNX
// p0x,p0y - `_̍W
// fgColor - OiF
    public function draw(graphics:Graphics,trans:Matrix3D,
      	      	      	 p0x:Number,p0y:Number,fgColor:uint):void{
      var pt:Array=body.vertices();
      var ii:int=0;
      for(var i:int=0;i<p.length;i++){
      	for(var j:int=0;j<p[i].length;j++){
      	  vp[i][j].x=vCoef*(pt[i][j].x-po.x);
      	  vp[i][j].y=vCoef*(pt[i][j].y-po.y);
      	  vp[i][j].z=vCoef*(pt[i][j].z-po.z);
      	  vp[i][j]=trans.transformVector(vp[i][j]);
      	  p[i][j].x=p0x+vp[i][j].x;
      	  p[i][j].y=p0y-vp[i][j].y;
      	  graphics.beginFill(fgColor);
      	  graphics.drawCircle(p[i][j].x,p[i][j].y,2);
      	  graphics.endFill();
      	  coords[ii]=p[i][j].x;
      	  coords[ii+1]=p[i][j].y;
      	  ii+=2;
      	}
      	coords[ii]=p[i][0].x;
      	coords[ii+1]=p[i][0].y;
      	ii+=2;
      }
      for(i=0;i<p.length-1;i++){
      	for(j=0;j<p[i].length;j++){
      	  coords[ii]=p[i][j].x;
      	  coords[ii+1]=p[i][j].y;
      	  coords[ii+2]=p[i+1][j].x;
      	  coords[ii+3]=p[i+1][j].y;
      	  ii+=4;
      	}
      }
      graphics.drawPath(commands,coords);
    }
  }
}
