package{
  import flash.geom.Vector3D;
  import figure.DefaultMatrix;
  import figure.Point3D;

//--------------------------------------------------------------------//
// ʒu
  public class Position{

// dSʒu
    public var x:Point3D;

// x
    public var v:Vector3D;

// x
    public var a:Vector3D;

// IC[p[^
    public var p:EulerParameters;

// px
    public var w:Vector3D;

// px
    public var dw:Vector3D;

//--------------------------------------------------------------------//
// ʒu\z
    public function Position(){
      x=new Point3D();
      v=new Vector3D();
      a=new Vector3D();
      p=new EulerParameters();
      w=new Vector3D();
      dw=new Vector3D();
    }

//--------------------------------------------------------------------//
// ʒuxNgԂ
// r - ̍Ẅʒu
    public function vector(r:Point3D):Vector.<Number>{
      var ps:Vector.<Number>=pointToVector(x);
      var ps2:Vector.<Number>=pointToVector(r);
      ps2=p.rotateMatrix().mulVector(ps2);
      for(var i:int=i;i<3;i++){
      	ps[i]+=ps2[i];
      }
      return ps;
    }

//--------------------------------------------------------------------//
// xxNgԂ
// r - ̍Ẅʒu
    public function velVector(r:Point3D):Vector.<Number>{
      var vl:Vector.<Number>=vectorToVector(v);
      var vl2:Vector.<Number>=tildep(r).mulVector(vectorToVector(w));
      vl2=p.rotateMatrix().mulVector(vl2);
      for(var i:int=i;i<3;i++){
      	vl[i]-=vl2[i];
      }
      return vl;
    }

//--------------------------------------------------------------------//
// dSʒuExݒ肷
// rl - w_̍̕Wʒu
// xg - w_̑S̍Wʒu
// vg - w_̑x
    public function setGcPosition(rl:Point3D,xg:Point3D,
      	      	      	      	  vg:Vector3D):void{
      var xv1:Vector.<Number>=pointToVector(xg);
      var xv2:Vector.<Number>=pointToVector(rl);
      xv2=p.rotateMatrix().mulVector(xv2);
      x.set(xv1[0]-xv2[0],xv1[1]-xv2[1],xv1[2]-xv2[2]);
      var vv1:Vector.<Number>=vectorToVector(vg);
      var vv2:Vector.<Number>=tildep(rl).mulVector(vectorToVector(w));
      vv2=p.rotateMatrix().mulVector(vv2);
      v.x=vv1[0]-vv2[0];
      v.y=vv1[1]-vv2[1];
      v.z=vv1[2]-vv2[2];
    }

//--------------------------------------------------------------------//
// ̍WʒuS̍Wɕϊ
// pt - Wʒu
    public function transPoint(pt:Point3D):void{
      var ps1:Vector.<Number>=pointToVector(x);
      var ps2:Vector.<Number>=pointToVector(pt);
      ps2=p.rotateMatrix().mulVector(ps2);
      pt.set(ps1[0]-ps2[0],ps1[1]-ps2[1],ps1[2]-ps2[2]);
    }

//--------------------------------------------------------------------//
// ̍WʒuS̍Wɕϊ
// pt - Wʒui[z
    public function trans(pt:Array):void{
      for(var i:int=0;i<pt.length;i++){
      	for(var j:int=0;j<pt[i].length;j++){
      	  transPoint(pt[i][j]);
      	}
      }
    }

//--------------------------------------------------------------------//
// IC[p[^̕ωʂ̂Q{ LւԂ
    public function eulerVel():Vector.<Number>{
      return p.matrixL().transposition().mulVector(vectorToVector(w));
    }

//--------------------------------------------------------------------//
// xݒ肷
// av - xxNg
// i0 - f[^̊JnCfbNX
    public function setAcc(av:Vector.<Number>,i0:int):void{
      a.x=av[i0];
      a.y=av[i0+1];
      a.z=av[i0+2];
      dw.x=av[i0+3];
      dw.y=av[i0+4];
      dw.z=av[i0+5];
    }

//--------------------------------------------------------------------//
// f[^XV
// dx - dSʒu̕ω
// dv - x̕ω
// dp - IC[p[^̕ω
// dw - px̕ω
    public function update1(dx:Vector3D,dv:Vector3D,dp:Vector.<Number>,
      	      	      	    dw:Vector3D):void{
      x.add(dx);
      v=v.add(dv);
      p.add(dp[0],dp[1],dp[2],dp[3]);
      w=w.add(dw);
      p.normalize();
    }

//--------------------------------------------------------------------//
// f[^XV
// c - W
// dx - dSʒu̕ω
// dv - x̕ω
// dp - IC[p[^̕ω
// dw - px̕ω
    public function update2(c:Number,dx:Vector3D,dv:Vector3D,
      	      	      	    dp:Vector.<Number>,dw:Vector3D):void{
      x.x+=c*dx.x;
      x.y+=c*dx.y;
      x.z+=c*dx.z;
      v.x+=c*dv.x;
      v.y+=c*dv.y;
      v.z+=c*dv.z;
      var ch:Number=0.5*c;
      p.add(ch*dp[0],ch*dp[1],ch*dp[2],ch*dp[3]);
      w.x+=c*dw.x;
      w.y+=c*dw.y;
      w.z+=c*dw.z;
    }

//--------------------------------------------------------------------//
// ʒũRs[Ԃ
    public function copy():Position{
      var pos:Position=new Position();
      pos.x=x.copy();
      pos.v=v.clone();
      pos.a=a.clone();
      pos.p=p.copy();
      pos.w=w.clone();
      pos.dw=dw.clone();
      return pos;
    }

//--------------------------------------------------------------------//
// xNgɕϊ
// p - ϊ_
    public static function pointToVector(p:Point3D):Vector.<Number>{
      return Vector.<Number>([p.x,p.y,p.z]);
    }

//--------------------------------------------------------------------//
// xNgɕϊ
// v - ϊxNg
    public static function vectorToVector(v:Vector3D):Vector.<Number>{
      return Vector.<Number>([v.x,v.y,v.z]);
    }

//--------------------------------------------------------------------//
// `_}gbNXԂ
// p - ϊ_
    public static function tildep(p:Point3D):DefaultMatrix{
      return tilde(p.x,p.y,p.z);
    }

//--------------------------------------------------------------------//
// `_}gbNXԂ
// p - ϊxNg
    public static function tildev(v:Vector3D):DefaultMatrix{
      return tilde(v.x,v.y,v.z);
    }

//--------------------------------------------------------------------//
// `_}gbNXԂ
// x,y,z - ϊxNgx,y,zW
    public static function tilde(x:Number,y:Number,
      	      	      	      	 z:Number):DefaultMatrix{
      var m:DefaultMatrix=new DefaultMatrix(3,3);
      m.set(0,1,-z);
      m.set(0,2,y);
      m.set(1,0,z);
      m.set(1,2,-x);
      m.set(2,0,-y);
      m.set(2,1,x);
      return m;
    }
  }
}
