package body{
  import figure.Point3D;

//--------------------------------------------------------------------//
// pNX
  public class Box extends Body{

// x
    public var a:Number;

// y
    public var b:Number;

// z
    public var c:Number;

// x
    public var density:Number;

//--------------------------------------------------------------------//
// ̂\z
// label f[^x
// a - x
// b - y
// c - z
// density - x
    public function Box(label:int,a:Number,b:Number,c:Number,
      	      	      	density:Number){
      super(label);
      this.a=a;
      this.b=b;
      this.c=c;
      this.density=density;
      mass=density*a*b*c;
      var ic:Number=mass/12.0;
      inertia[0][0]=ic*(b*b+c*c);
      inertia[1][1]=ic*(c*c+a*a);
      inertia[2][2]=ic*(a*a+b*b);
      pt=new Array(2);
      for(var i:int=0;i<2;i++){
      	pt[i]=new Vector.<Point3D>(4,true);
      	for(var j:int=0;j<4;j++){
      	  pt[i][j]=new Point3D();
      	}
      }
    }

//--------------------------------------------------------------------//
// ̌`\_̃XgԂ
    public override function vertices():Array{
      var ah:Number=0.5*a;
      var bh:Number=0.5*b;
      var ch:Number=0.5*c;
      pt[0][0].set(ah,bh,ch);
      pt[0][1].set(ah,-bh,ch);
      pt[0][2].set(-ah,-bh,ch);
      pt[0][3].set(-ah,bh,ch);
      pt[1][0].set(ah,bh,-ch);
      pt[1][1].set(ah,-bh,-ch);
      pt[1][2].set(-ah,-bh,-ch);
      pt[1][3].set(-ah,bh,-ch);
      p.trans(pt);
      return pt;
    }

//--------------------------------------------------------------------//
// f[^Ԃ
    public function toString():String{
      return "Box\t"+label+"\t"+a+"\t"+b+"\t"+c+"\t"+density;
    }
  }
}
