package constraint{
  import flash.geom.Vector3D;
  import figure.DefaultMatrix;
  import figure.Point3D;

//--------------------------------------------------------------------//
// S̒ۃX[p[NX
  public class AbstractConstraint implements Constraint{

// SΏۈʒuP̃CfbNX
    protected var pp1:int;

// SΏۈʒuQ̃CfbNX
    protected var pp2:int;

// SΏە̂P̍Sʒu
    protected var r1:Point3D;

// SΏە̂Q̍Sʒu
    protected var r2:Point3D;

// S׏dxNg
    protected var vector:Vector.<Number>;

//--------------------------------------------------------------------//
// S\z
// p1 - SΏۈʒuP̃CfbNX
// p2 - SΏۈʒuQ̃CfbNX
// r1 - SΏە̂P̍Sʒu
// r2 - SΏە̂Q̍Sʒu
    public function AbstractConstraint(p1:int,p2:int,
      	      	      	      	       r1:Point3D,r2:Point3D){
      setPosition(p1,p2);
      setCoords(r1,r2);
    }

//--------------------------------------------------------------------//
// S鎩RxԂ
    public function dof():int{
      return 0;
    }

//--------------------------------------------------------------------//
// SΏە̂P̃CfbNXԂ
    public function p1():int{
      return pp1;
    }

//--------------------------------------------------------------------//
// SΏە̂Q̃CfbNXԂ
    public function p2():int{
      return pp2;
    }

//--------------------------------------------------------------------//
// SΏۈʒuݒ肷
// pp1 - SΏۈʒuP̃CfbNX
// pp2 - SΏۈʒuQ̃CfbNX
    public function setPosition(pp1:int,pp2:int):void{
      this.pp1=pp1;
      this.pp2=pp2;
    }

//--------------------------------------------------------------------//
// Sʒuݒ肷
// r1 - SΏە̂P̍Sʒu
// r2 - SΏە̂Q̍Sʒu
    public function setCoords(r1:Point3D,r2:Point3D):void{
      this.r1=r1;
      this.r2=r2;
    }

//--------------------------------------------------------------------//
// SΏە̂PƂQւ
    public function swap():void{
      var temp:int=pp1;
      pp1=pp2;
      pp2=temp;
      var tp:Point3D=r1;
      r1=r2;
      r2=tp;
    }

//--------------------------------------------------------------------//
// S}gbNXES׏dxNg쐬
// p1 - SΏۈʒuP
// p2 - SΏۈʒuQ
    public function create(p1:Position,p2:Position):void{
    }

//--------------------------------------------------------------------//
// S׏dxNgԂ
    public function getVector():Vector.<Number>{
      return vector;
    }

//--------------------------------------------------------------------//
// `_}gbNXԂ
// v - xNg
    public static function tilde(v:Vector.<Number>):DefaultMatrix{
      return Position.tilde(v[0],v[1],v[2]);
    }

//--------------------------------------------------------------------//
// s̐ςvZ
// m1 - sP
// m2 - sQ
    public static function mul2(m1:DefaultMatrix,m2:DefaultMatrix)
      	      	      	       :DefaultMatrix{
      return DefaultMatrix.mulMatrix(m1,m2);
    }

//--------------------------------------------------------------------//
// s̐ςvZ
// m1 - sP
// m2 - sQ
// m3 - sR
    public static function mul3(m1:DefaultMatrix,m2:DefaultMatrix,
      	      	      	      	m3:DefaultMatrix):DefaultMatrix{
      return mul2(mul2(m1,m2),m3);
    }

//--------------------------------------------------------------------//
// s̐ςvZ
// m1 - sP
// m2 - sQ
// m3 - sR
// m4 - sS
    public static function mul4(m1:DefaultMatrix,m2:DefaultMatrix,
      	      	      	      	m3:DefaultMatrix,m4:DefaultMatrix)
      	      	      	       :DefaultMatrix{
      return mul2(mul2(m1,m2),mul2(m3,m4));
    }

//--------------------------------------------------------------------//
// sƌW̐ςvZ
// c - W
// m - s
    public static function mul(c:Number,m:DefaultMatrix):DefaultMatrix{
      m.mul(c);
      return m;
    }

//--------------------------------------------------------------------//
// sƃxNg̐ςvZ
// m - s
// v - xNg
  public static function mulv(m:DefaultMatrix,
      	      	      	      v:Vector3D):Vector.<Number>{
    return m.mulVector(Position.vectorToVector(v));
  }

//--------------------------------------------------------------------//
// sƃxNg̐ςvZ
// m - s
// p - xNgW
  public static function mulp(m:DefaultMatrix,
      	      	      	      p:Point3D):Vector.<Number>{
    return mulvn(m,Position.pointToVector(p));
  }

//--------------------------------------------------------------------//
// sƃxNg̐ςvZ
// m - s
// v - xNg
  public static function mulvn(m:DefaultMatrix,
      	      	      	       v:Vector.<Number>):Vector.<Number>{
    return m.mulVector(v);
  }

//--------------------------------------------------------------------//
// sƃxNg̐ςvZ
// m1 - sP
// m2 - sQ
// v - xNg
  public static function mulv2(m1:DefaultMatrix,m2:DefaultMatrix,
      	      	      	       v:Vector3D):Vector.<Number>{
    return mul2(m1,m2).mulVector(Position.vectorToVector(v));
  }

//--------------------------------------------------------------------//
// sƃxNg̐ςvZ
// m1 - sP
// m2 - sQ
// p - xNgW
  public static function mulp2(m1:DefaultMatrix,m2:DefaultMatrix,
      	      	      	       p:Point3D):Vector.<Number>{
    return mul2(m1,m2).mulVector(Position.pointToVector(p));
  }

//--------------------------------------------------------------------//
/*
// sƃxNg̐ςvZ
// m1 - sP
// m2 - sQ
// v - xNg
  public static Vector mulv2(m1:DefaultMatrix,m2:DefaultMatrix,
      	      	      	     v:Vector.<Number>):Vector.<Number>{
    return mul2(m1,m2).mulVector(v);
  }
*/

//--------------------------------------------------------------------//
// s̘avZ
// m1 - sP
// m2 - sQ
    public static function add2(m1:DefaultMatrix,m2:DefaultMatrix)
      	      	      	       :DefaultMatrix{
      m1.addMatrix(m2);
      return m1;
    }

//--------------------------------------------------------------------//
// s̘avZ
// m1 - sP
// m2 - sQ
// m3 - sR
    public static function add3(m1:DefaultMatrix,m2:DefaultMatrix,
      	      	      	      	m3:DefaultMatrix):DefaultMatrix{
      m1.addMatrix(m2);
      m1.addMatrix(m3);
      return m1;
    }

//--------------------------------------------------------------------//
// s̘avZ
// m1 - sP
// m2 - sQ
// m3 - sR
// m4 - sS
    public static function add4(m1:DefaultMatrix,m2:DefaultMatrix,
      	      	      	      	m3:DefaultMatrix,m4:DefaultMatrix)
      	      	      	       :DefaultMatrix{
      m1.addMatrix(m2);
      m1.addMatrix(m3);
      m1.addMatrix(m4);
      return m1;
    }

//--------------------------------------------------------------------//
// xNg̘avZ
// v1 - xNgP
// v2 - xNgQ
    public static function addv2(v1:Vector.<Number>,
      	      	      	      	 v2:Vector.<Number>):Vector.<Number>{
      for(var i:int=0;i<v1.length;i++){
      	v1[i]+=v2[i];
      }
      return v1;
    }

//--------------------------------------------------------------------//
// xNg̘avZ
// v1 - xNgP
// v2 - xNgQ
// v3 - xNgR
// v4 - xNgS
    public static function addv4(v1:Vector.<Number>,
      	      	      	      	 v2:Vector.<Number>,
      	      	      	      	 v3:Vector.<Number>,
      	      	      	      	 v4:Vector.<Number>):Vector.<Number>{
      for(var i:int=0;i<v1.length;i++){
      	v1[i]+=v2[i]+v3[i]+v4[i];
      }
      return v1;
    }

//--------------------------------------------------------------------//
// xNg̐Ԃ̃XgA
// v - xNg
    public static function compList(v:Vector.<Number>):Vector.<int>{
      var index:Vector.<int>=new Vector.<int>(v.length,true);
      var vv:Vector.<Number>=new Vector.<Number>(v.length,true);
      for(var i:int=0;i<v.length;i++){
      	index[i]=i;
      	vv[i]=Math.abs(v[i]);
      }
      for(i=1;i<v.length;i++){
      	var tv:Number=vv[i];
      	var ti:int=index[i];
      	if(vv[i-1]>tv){
      	  var j:int=i;
      	  do{
      	    vv[j]=vv[j-1];
      	    index[j]=index[j-1];
      	    j--;
      	  }while((j>0) && (vv[j-1]>tv));
      	  vv[j]=tv;
      	  index[j]=ti;
      	}
      }
      return index;
    }
  }
}
