package constraint{
  import flash.geom.Vector3D;
  import figure.DefaultMatrix;
  import figure.Point3D;

//--------------------------------------------------------------------//
// WCg
  public class BallJoint extends AbstractRigidConstraint{

// S鎩Rx
    public static const DOF:int=3;

//--------------------------------------------------------------------//
// WCg\z
// p1 - SΏۈʒuP̃CfbNX
// p2 - SΏۈʒuQ̃CfbNX
// r1 - SΏە̂P̍Sʒu
// r2 - SΏە̂Q̍Sʒu
    public function BallJoint(p1:int,p2:int,r1:Point3D,r2:Point3D){
      super(p1,p2,r1,r2);
      vector=new Vector.<Number>(DOF,true);
    }

//--------------------------------------------------------------------//
// S鎩RxԂ
    public override function dof():int{
      return DOF;
    }

//--------------------------------------------------------------------//
// dSʒuExݒ肷
// p1 - SΏۈʒuP
// p2 - SΏۈʒuQ
    public override function setGcPosition(p1:Position,
      	      	      	      	      	   p2:Position):void{
      if(p1==null){
      	p2.setGcPosition(r2,r1,new Vector3D());
      }
      else if(p2==null){
      	p1.setGcPosition(r1,r2,new Vector3D());
      }
      else{
      	var x:Vector.<Number>=p1.vector(r1);
      	var v:Vector.<Number>=p1.velVector(r1);
      	p2.setGcPosition(r2,new Point3D(x[0],x[1],x[2]),
      	      	      	 new Vector3D(v[0],v[1],v[2],1.0));
      }
    }

//--------------------------------------------------------------------//
// S}gbNXES׏dxNg쐬
// p1 - SΏۈʒuP
// p2 - SΏۈʒuQ
    public override function create(p1:Position,p2:Position):void{
      for(var i:int=0;i<DOF;i++) vector[i]=0.0;
      if(p1!=null) matrix[0]=new DefaultMatrix(DOF,6);
      if(p2!=null) matrix[1]=new DefaultMatrix(DOF,6);
      point(p1,p2,0);
    }

//--------------------------------------------------------------------//
// f[^Ԃ
    public function toString():String{
      return "BallJoint\t"+pp1+"\t"+pp2+"\t"+r1.x+"\t"+r1.y+"\t"+r1.z
      	    +"\t"+r2.x+"\t"+r2.y+"\t"+r2.z;
    }
  }
}
