package constraint{
  import flash.geom.Vector3D;
  import figure.DefaultMatrix;
  import figure.Point3D;

//--------------------------------------------------------------------//
// jo[TWCg
  public class UniversalJoint extends AbstractRigidConstraint{

// S鎩Rx
    public static const DOF:int=4;

// SΏە̂P̉]
    protected var b1x:Vector3D;

// SΏە̂Q̉]
    protected var b2y:Vector3D;

//--------------------------------------------------------------------//
// jo[TWCg\z
// p1 - SΏۈʒuP̃CfbNX
// p2 - SΏۈʒuQ̃CfbNX
// r1 - SΏە̂P̍Sʒu
// r2 - SΏە̂Q̍Sʒu
    public function UniversalJoint(p1:int,p2:int,r1:Point3D,r2:Point3D){
      super(p1,p2,r1,r2);
      vector=new Vector.<Number>(DOF,true);
      b1x=new Vector3D(1.0,0.0,0.0,1.0);
      b2y=new Vector3D(0.0,1.0,0.0,1.0);
      matrix[0]=new DefaultMatrix(DOF,6);
      matrix[1]=new DefaultMatrix(DOF,6);
    }

//--------------------------------------------------------------------//
// S鎩RxԂ
    public override function dof():int{
      return DOF;
    }

//--------------------------------------------------------------------//
// SΏە̂̎ݒ肷
// b1x - SΏە̂P̉]
// b2y - SΏە̂Q̉]
    public function setAxis(b1x:Vector3D,b2y:Vector3D):void{
      this.b1x=b1x;
      this.b2y=b2y;
    }

//--------------------------------------------------------------------//
// dSʒuExݒ肷
// p1 - SΏۈʒuP
// p2 - SΏۈʒuQ
    public override function setGcPosition(p1:Position,
      	      	      	      	      	   p2:Position):void{
      var x:Vector.<Number>=p1.vector(r1);
      var v:Vector.<Number>=p1.velVector(r1);
      p2.setGcPosition(r2,new Point3D(x[0],x[1],x[2]),
      	      	       new Vector3D(v[0],v[1],v[2],1.0));
    }

//--------------------------------------------------------------------//
// S}gbNXES׏dxNg쐬
// p1 - SΏۈʒuP
// p2 - SΏۈʒuQ
    public override function create(p1:Position,p2:Position):void{
      for(var i:int=0;i<DOF;i++) vector[i]=0.0;
      point(p1,p2,0);
      rotate(p1,p2,b1x,b2y,3);
    }

//--------------------------------------------------------------------//
// f[^Ԃ
    public function toString():String{
      return "UniversalJoint\t"+pp1+"\t"+pp2+"\t"+r1.x+"\t"+r1.y
      	    +"\t"+r1.z+"\t"+r2.x+"\t"+r2.y+"\t"+r2.z;
    }
  }
}
